diff -urN qmail-1.03-vanilla/alloc.c qmail-1.03-md24/alloc.c
--- qmail-1.03-vanilla/alloc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/alloc.c	2007-07-19 22:04:02.000000000 +0200
@@ -1,7 +1,7 @@
 #include "alloc.h"
 #include "error.h"
-extern char *malloc();
-extern void free();
+
+#include <stdlib.h>
 
 #define ALIGNMENT 16 /* XXX: assuming that this alignment is enough */
 #define SPACE 4096 /* must be multiple of ALIGNMENT */
diff -urN qmail-1.03-vanilla/auto-gid.c qmail-1.03-md24/auto-gid.c
--- qmail-1.03-vanilla/auto-gid.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/auto-gid.c	2007-07-19 20:56:22.000000000 +0200
@@ -16,7 +16,7 @@
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -47,5 +47,5 @@
   outs(strnum);
   outs(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/auto-int8.c qmail-1.03-md24/auto-int8.c
--- qmail-1.03-vanilla/auto-int8.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/auto-int8.c	2007-07-19 20:56:22.000000000 +0200
@@ -7,13 +7,13 @@
 char buf1[256];
 substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
 
-void puts(s)
+void out(s)
 char *s;
 {
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -30,11 +30,11 @@
   scan_8long(value,&num);
   strnum[fmt_ulong(strnum,num)] = 0;
 
-  puts("int ");
-  puts(name);
-  puts(" = ");
-  puts(strnum);
-  puts(";\n");
+  out("int ");
+  out(name);
+  out(" = ");
+  out(strnum);
+  out(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/auto-int.c qmail-1.03-md24/auto-int.c
--- qmail-1.03-vanilla/auto-int.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/auto-int.c	2007-07-19 20:56:22.000000000 +0200
@@ -7,13 +7,13 @@
 char buf1[256];
 substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
 
-void puts(s)
+void out(s)
 char *s;
 {
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -30,11 +30,11 @@
   scan_ulong(value,&num);
   strnum[fmt_ulong(strnum,num)] = 0;
 
-  puts("int ");
-  puts(name);
-  puts(" = ");
-  puts(strnum);
-  puts(";\n");
+  out("int ");
+  out(name);
+  out(" = ");
+  out(strnum);
+  out(";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/auto-str.c qmail-1.03-md24/auto-str.c
--- qmail-1.03-vanilla/auto-str.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/auto-str.c	2007-07-19 20:56:22.000000000 +0200
@@ -5,13 +5,13 @@
 char buf1[256];
 substdio ss1 = SUBSTDIO_FDBUF(write,1,buf1,sizeof(buf1));
 
-void puts(s)
+void out(s)
 char *s;
 {
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -25,20 +25,20 @@
   value = argv[2];
   if (!value) _exit(100);
 
-  puts("char ");
-  puts(name);
-  puts("[] = \"\\\n");
+  out("char ");
+  out(name);
+  out("[] = \"\\\n");
 
-  while (ch = *value++) {
-    puts("\\");
+  while ((ch = *value++)) {
+    out("\\");
     octal[3] = 0;
     octal[2] = '0' + (ch & 7); ch >>= 3;
     octal[1] = '0' + (ch & 7); ch >>= 3;
     octal[0] = '0' + (ch & 7);
-    puts(octal);
+    out(octal);
   }
 
-  puts("\\\n\";\n");
+  out("\\\n\";\n");
   if (substdio_flush(&ss1) == -1) _exit(111);
-  _exit(0);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/auto-uid.c qmail-1.03-md24/auto-uid.c
--- qmail-1.03-vanilla/auto-uid.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/auto-uid.c	2007-07-19 20:56:22.000000000 +0200
@@ -16,7 +16,7 @@
   if (substdio_puts(&ss1,s) == -1) _exit(111);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/base64.c qmail-1.03-md24/base64.c
--- qmail-1.03-vanilla/base64.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/base64.c	2007-08-12 10:22:00.000000000 +0200
@@ -0,0 +1,79 @@
+#include "base64.h"
+#include "stralloc.h"
+#include "str.h"
+
+const char base64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
+
+static inline int dec(unsigned char x) {
+  if (x>='A' && x<='Z') return x-'A';
+  if (x>='a' && x<='z') return x-'a'+26;
+  if (x>='0' && x<='9') return x-'0'+26+26;
+  switch (x) {
+  case '+': return 62;
+  case '/': return 63;
+  default: return -1;
+  }
+}
+
+unsigned long scan_base64(const char *src,char *dest,unsigned long *destlen) {
+  unsigned short tmp=0,bits=0;
+  register const unsigned char* s=(const unsigned char*) src;
+  const char* orig=dest;
+  for (;;) {
+    int a=dec(*s);
+    if (a<0) {
+      while (*s=='=') ++s;
+      break;
+    }
+    tmp=(tmp<<6)|a; bits+=6;
+    ++s;
+    if (bits>=8) {
+      *dest=(tmp>>(bits-=8));
+      ++dest;
+    }
+  }
+  *destlen=dest-orig;
+  return (const char*)s-src;
+}
+
+unsigned long fmt_base64(char* dest,const char* src,unsigned long len) {
+  register const unsigned char* s=(const unsigned char*) src;
+  unsigned short bits=0,temp=0;
+  unsigned long written=0,i;
+  if (!dest) return ((len+2)/3)*4;
+  for (i=0; i<len; ++i) {
+    temp<<=8; temp+=s[i]; bits+=8;
+    while (bits>6) {
+      dest[written]=base64[((temp>>(bits-6))&63)];
+      ++written; bits-=6;
+    }
+  }
+  if (bits) {
+    temp<<=(6-bits);
+    dest[written]=base64[temp&63];
+    ++written;
+  }
+  while (written&3) { dest[written]='='; ++written; }
+  return written;
+}
+
+/* returns 0 ok, 1 illegal */
+int b64decode(stralloc *out, const char *in, int l)
+{
+  if (!stralloc_readyplus(out, str_len(in))) return 1;
+  scan_base64(in, out->s, &out->len);
+
+  return 0;
+}
+
+
+/* returns 0 ok, 1 illegal */
+int b64encode(stralloc *out, stralloc *in)
+{
+  if (stralloc_readyplus(out, fmt_base64(0,in->s,in->len))) {
+    out->len+=fmt_base64(out->s+out->len,in->s,in->len);
+    return 0;
+  }
+
+  return 1;
+}
diff -urN qmail-1.03-vanilla/base64.h qmail-1.03-md24/base64.h
--- qmail-1.03-vanilla/base64.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/base64.h	2007-08-12 10:02:00.000000000 +0200
@@ -0,0 +1,12 @@
+#ifndef BASE64_H
+#define BASE64_H
+
+#include "stralloc.h"
+
+extern unsigned long scan_base64(const char *src,char *dest,unsigned long *destlen);
+extern unsigned long fmt_base64(char* dest,const char* src,unsigned long len);
+
+extern int b64decode(stralloc *out, const char *in, int l);
+extern int b64encode(stralloc *out, stralloc *in);
+
+#endif
diff -urN qmail-1.03-vanilla/bouncesaying.c qmail-1.03-md24/bouncesaying.c
--- qmail-1.03-vanilla/bouncesaying.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/bouncesaying.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "fork.h"
 #include "strerr.h"
 #include "error.h"
@@ -7,7 +9,7 @@
 
 #define FATAL "bouncesaying: fatal: "
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -38,4 +40,5 @@
   }
 
   strerr_die1x(100,argv[1]);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/byte_cspn.c qmail-1.03-md24/byte_cspn.c
--- qmail-1.03-vanilla/byte_cspn.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/byte_cspn.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,11 @@
+#include "byte.h"
+
+unsigned int byte_cspn(s,n,c)
+register char *s;
+register unsigned int n;
+register char *c;
+{
+  while(*c)
+    n = byte_chr(s,n,*c++);
+  return n;
+}
diff -urN qmail-1.03-vanilla/byte.h qmail-1.03-md24/byte.h
--- qmail-1.03-vanilla/byte.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/byte.h	2007-07-19 20:56:22.000000000 +0200
@@ -3,9 +3,12 @@
 
 extern unsigned int byte_chr();
 extern unsigned int byte_rchr();
+extern unsigned int byte_cspn();
+extern unsigned int byte_rcspn();
+
+extern int byte_diff();
 extern void byte_copy();
 extern void byte_copyr();
-extern int byte_diff();
 extern void byte_zero();
 
 #define byte_equal(s,n,t) (!byte_diff((s),(n),(t)))
diff -urN qmail-1.03-vanilla/byte_rcspn.c qmail-1.03-md24/byte_rcspn.c
--- qmail-1.03-vanilla/byte_rcspn.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/byte_rcspn.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,17 @@
+#include "byte.h"
+
+unsigned int byte_rcspn(s,n,c)
+register char *s;
+register unsigned int n;
+register char *c;
+{
+  unsigned int ret,pos,i;
+
+  for(ret = n,pos = 0;*c;++c) {
+    i = byte_rchr(s + pos,n - pos,*c) + pos;
+    if (i < n) ret = pos = i;
+  }
+
+  return ret;
+}
+
diff -urN qmail-1.03-vanilla/case_lowers.c qmail-1.03-md24/case_lowers.c
--- qmail-1.03-vanilla/case_lowers.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/case_lowers.c	2007-07-19 20:56:22.000000000 +0200
@@ -4,7 +4,7 @@
 char *s;
 {
   unsigned char x;
-  while (x = *s) {
+  while ((x = *s)) {
     x -= 'A';
     if (x <= 'Z' - 'A') *s = x + 'a';
     ++s;
diff -urN qmail-1.03-vanilla/cdb.h qmail-1.03-md24/cdb.h
--- qmail-1.03-vanilla/cdb.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/cdb.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,8 @@
 #ifndef CDB_H
 #define CDB_H
 
+#include <sys/types.h>
+#include <unistd.h>
 #include "uint32.h"
 
 extern uint32 cdb_hash();
diff -urN qmail-1.03-vanilla/cdbmss.h qmail-1.03-md24/cdbmss.h
--- qmail-1.03-vanilla/cdbmss.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/cdbmss.h	2007-07-19 20:56:22.000000000 +0200
@@ -4,6 +4,10 @@
 #include "cdbmake.h"
 #include "substdio.h"
 
+extern int cdbmss_start();
+extern int cdbmss_add();
+extern int cdbmss_finish();
+
 struct cdbmss {
   char ssbuf[1024];
   struct cdbmake cdbm;
@@ -11,6 +15,8 @@
   char packbuf[8];
   uint32 pos;
   int fd;
-} ;
+};
 
 #endif
+
+
diff -urN qmail-1.03-vanilla/cdb_seek.c qmail-1.03-md24/cdb_seek.c
--- qmail-1.03-vanilla/cdb_seek.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/cdb_seek.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,7 +1,5 @@
-#include <sys/types.h>
-#include <errno.h>
-extern int errno;
 #include "cdb.h"
+#include "error.h"
 
 #ifndef SEEK_SET
 #define SEEK_SET 0
diff -urN qmail-1.03-vanilla/chkshsgr.c qmail-1.03-md24/chkshsgr.c
--- qmail-1.03-vanilla/chkshsgr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/chkshsgr.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,9 @@
+#include <sys/types.h>
+#include <unistd.h>
+#include <grp.h>
+
 #include "exit.h"
-void main()
+int main()
 {
  short x[4];
 
diff -urN qmail-1.03-vanilla/chkspawn.c qmail-1.03-md24/chkspawn.c
--- qmail-1.03-vanilla/chkspawn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/chkspawn.c	2007-07-19 20:56:22.000000000 +0200
@@ -8,7 +8,7 @@
 char num[FMT_ULONG];
 fd_set fds;
 
-void main()
+int main()
 {
   unsigned long hiddenlimit;
   unsigned long maxnumd;
@@ -22,8 +22,8 @@
     _exit(1);
   }
 
-  if (auto_spawn > 255) {
-    substdio_puts(subfderr,"Oops. You have set conf-spawn higher than 255.\n");
+  if (auto_spawn > 65000) {
+    substdio_puts(subfderr,"Oops. You have set conf-spawn higher than 65000.\n");
     substdio_flush(subfderr);
     _exit(1);
   }
diff -urN qmail-1.03-vanilla/commands.c qmail-1.03-md24/commands.c
--- qmail-1.03-vanilla/commands.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/commands.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,13 +1,33 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "commands.h"
 #include "substdio.h"
 #include "stralloc.h"
 #include "str.h"
+#include "fmt.h"
 #include "case.h"
 
 static stralloc cmd = {0};
 
-int commands(ss,c)
+static void logit(substdio *ll, char *str)
+{
+  static int pid=0;
+  char pidstr[FMT_ULONG];
+
+  if (!pid) { pid=getpid(); }
+  pidstr[fmt_ulong(pidstr,pid)] = 0;
+  substdio_puts(ll,name);
+  substdio_puts(ll,": pid ");
+  substdio_puts(ll,pidstr);
+  substdio_puts(ll," C: ");
+  substdio_puts(ll,str);
+  substdio_puts(ll,"\n");
+  substdio_flush(ll);
+}
+
+int commands(ss,ll,c)
 substdio *ss;
+substdio *ll;
 struct commands *c;
 {
   int i;
@@ -22,12 +42,21 @@
       if (i != 1) return i;
       if (cmd.s[cmd.len] == '\n') break;
       ++cmd.len;
+  
+      if (ctl_maxcmdlen)
+        if (cmd.len > ctl_maxcmdlen) {
+	  die_lcmd(); /* long command detected! ... 
+	  we also don't log such things! */
+	}
     }
 
     if (cmd.len > 0) if (cmd.s[cmd.len - 1] == '\r') --cmd.len;
-
     cmd.s[cmd.len] = 0;
 
+    if (ctl_log_in > 0)
+      if (ll->fd>0)
+        logit(ll,cmd.s);
+
     i = str_chr(cmd.s,' ');
     arg = cmd.s + i;
     while (*arg == ' ') ++arg;
@@ -35,6 +64,7 @@
 
     for (i = 0;c[i].text;++i) if (case_equals(c[i].text,cmd.s)) break;
     c[i].fun(arg);
+
     if (c[i].flush) c[i].flush();
   }
 }
diff -urN qmail-1.03-vanilla/commands.h qmail-1.03-md24/commands.h
--- qmail-1.03-vanilla/commands.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/commands.h	2007-07-19 20:56:22.000000000 +0200
@@ -4,9 +4,14 @@
 struct commands {
   char *text;
   void (*fun)();
-  void (*flush)();
-} ;
+  int  (*flush)();
+};
+
+extern char *name; /* the name of the prog, which uses commands() */
+extern int ctl_log_in;
+extern int ctl_maxcmdlen; /* max length a smtp command may have */
 
 extern int commands();
+extern void die_lcmd();   /* we call this function, when the command is too long */
 
 #endif
diff -urN qmail-1.03-vanilla/condredirect.c qmail-1.03-md24/condredirect.c
--- qmail-1.03-vanilla/condredirect.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/condredirect.c	2007-07-19 20:56:22.000000000 +0200
@@ -28,7 +28,7 @@
 
 char num[FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -82,4 +82,5 @@
   qqx = qmail_close(&qqt);
   if (*qqx) strerr_die2x(*qqx == 'D' ? 100 : 111,FATAL,qqx + 1);
   strerr_die2x(99,"condredirect: qp ",num);
+  return 0;
 }
diff -urN qmail-1.03-vanilla/control.c qmail-1.03-md24/control.c
--- qmail-1.03-vanilla/control.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/control.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,17 +1,9 @@
-#include "readwrite.h"
-#include "open.h"
-#include "getln.h"
-#include "stralloc.h"
-#include "substdio.h"
-#include "error.h"
 #include "control.h"
-#include "alloc.h"
-#include "scan.h"
 
 static char inbuf[64];
 static stralloc line = {0};
-static stralloc me = {0};
-static int meok = 0;
+stralloc me = {0};
+int meok = 0;
 
 static void striptrailingwhitespace(sa)
 stralloc *sa;
@@ -74,7 +66,7 @@
 char *fn;
 {
  unsigned long u;
- switch(control_readline(&line,fn))
+ switch (control_readline(&line,fn))
   {
    case 0: return 0;
    case -1: return -1;
diff -urN qmail-1.03-vanilla/control.h qmail-1.03-md24/control.h
--- qmail-1.03-vanilla/control.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/control.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,20 @@
 #ifndef CONTROL_H
 #define CONTROL_H
 
+#include <sys/types.h>
+#include <unistd.h>
+#include "readwrite.h"
+#include "open.h"
+#include "getln.h"
+#include "stralloc.h"
+#include "substdio.h"
+#include "error.h"
+#include "alloc.h"
+#include "scan.h"
+
+extern int meok;
+extern stralloc me;
+
 extern int control_init();
 extern int control_readline();
 extern int control_rldef();
diff -urN qmail-1.03-vanilla/dns.c qmail-1.03-md24/dns.c
--- qmail-1.03-vanilla/dns.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dns.c	2007-07-19 20:56:22.000000000 +0200
@@ -4,13 +4,15 @@
 #include <netinet/in.h>
 #include <arpa/nameser.h>
 #include <resolv.h>
-#include <errno.h>
+
 extern int res_query();
 extern int res_search();
-extern int errno;
 extern int h_errno;
+
+#include "error.h"
 #include "ip.h"
 #include "ipalloc.h"
+#include "strsalloc.h"
 #include "fmt.h"
 #include "alloc.h"
 #include "str.h"
@@ -18,17 +20,22 @@
 #include "dns.h"
 #include "case.h"
 
+#define MAXTXT 256
+
 static unsigned short getshort(c) unsigned char *c;
 { unsigned short u; u = c[0]; return (u << 8) + c[1]; }
 
-static union { HEADER hdr; unsigned char buf[PACKETSZ]; } response;
+static struct { unsigned char *buf; } response;
+static int responsebuflen = 0;
 static int responselen;
 static unsigned char *responseend;
 static unsigned char *responsepos;
+static unsigned long saveresoptions;
 
 static int numanswers;
 static char name[MAXDNAME];
 static struct ip_address ip;
+static char txt[MAXTXT];
 unsigned short pref;
 
 static stralloc glue = {0};
@@ -45,18 +52,32 @@
  errno = 0;
  if (!stralloc_copy(&glue,domain)) return DNS_MEM;
  if (!stralloc_0(&glue)) return DNS_MEM;
- responselen = lookup(glue.s,C_IN,type,response.buf,sizeof(response));
+ if (!responsebuflen) response.buf = (unsigned char *)alloc(PACKETSZ+1);
+ if (response.buf) responsebuflen = PACKETSZ+1;
+ else return DNS_MEM;
+
+ responselen = lookup(glue.s,C_IN,type,response.buf,responsebuflen);
+ if ((responselen >= responsebuflen) ||
+     (responselen > 0 && (((HEADER *)response.buf)->tc)))
+  {
+   if (responsebuflen < 65536) {
+    if (alloc_re(&response.buf, responsebuflen, 65536))
+     responsebuflen = 65536;
+   } else return DNS_MEM;
+    saveresoptions = _res.options;
+    _res.options |= RES_USEVC;
+    responselen = lookup(glue.s,C_IN,type,response.buf,responsebuflen);
+    _res.options = saveresoptions;
+  }
  if (responselen <= 0)
   {
    if (errno == ECONNREFUSED) return DNS_SOFT;
    if (h_errno == TRY_AGAIN) return DNS_SOFT;
    return DNS_HARD;
   }
- if (responselen >= sizeof(response))
-   responselen = sizeof(response);
  responseend = response.buf + responselen;
  responsepos = response.buf + sizeof(HEADER);
- n = ntohs(response.hdr.qdcount);
+ n = ntohs(((HEADER *)response.buf)->qdcount);
  while (n-- > 0)
   {
    i = dn_expand(response.buf,responseend,responsepos,name,MAXDNAME);
@@ -66,7 +87,7 @@
    if (i < QFIXEDSZ) return DNS_SOFT;
    responsepos += QFIXEDSZ;
   }
- numanswers = ntohs(response.hdr.ancount);
+ numanswers = ntohs(((HEADER *)response.buf)->ancount);
  return 0;
 }
 
@@ -179,6 +200,38 @@
  return 0;
 }
 
+static int findtxt(wanttype)
+int wanttype;
+{
+ unsigned short rrtype;
+ unsigned short rrdlen;
+ int i;
+
+ if (numanswers <= 0) return 2;
+ --numanswers;
+ if (responsepos == responseend) return DNS_SOFT;
+
+ i = dn_expand(response.buf,responseend,responsepos,name,MAXDNAME);
+ if (i < 0) return DNS_SOFT;
+ responsepos += i;
+
+ i = responseend - responsepos;
+ if (i < 4 + 3 * 2) return DNS_SOFT;
+
+ rrtype = getshort(responsepos);
+ rrdlen = getshort(responsepos + 8);
+ responsepos += 10;
+
+ if (rrtype == wanttype) {
+  str_copyb(txt, responsepos, rrdlen);
+  responsepos += rrdlen;
+  return 1;
+ }
+
+ responsepos += rrdlen;
+ return 0;
+}
+
 void dns_init(flagsearch)
 int flagsearch;
 {
@@ -237,15 +290,18 @@
  return len;
 }
 
-int dns_ptr(sa,ip)
-stralloc *sa;
+static int dns_ptrplus(ssa,ip)
+strsalloc *ssa;
 struct ip_address *ip;
 {
+ stralloc sa = {0};
  int r;
 
- if (!stralloc_ready(sa,iaafmt((char *) 0,ip))) return DNS_MEM;
- sa->len = iaafmt(sa->s,ip);
- switch(resolve(sa,T_PTR))
+ if (!stralloc_ready(&sa,iaafmt((char *) 0,ip))) return DNS_MEM;
+ sa.len = iaafmt(sa.s,ip);
+ r = resolve(&sa,T_PTR);
+ alloc_free(sa.s);
+ switch(r)
   {
    case DNS_MEM: return DNS_MEM;
    case DNS_SOFT: return DNS_SOFT;
@@ -256,25 +312,46 @@
    if (r == DNS_SOFT) return DNS_SOFT;
    if (r == 1)
     {
-     if (!stralloc_copys(sa,name)) return DNS_MEM;
-     return 0;
+     stralloc sa2 = {0};
+     if (!stralloc_copys(&sa2,name)) return DNS_MEM;
+     if (!strsalloc_append(ssa,&sa2)) return DNS_MEM;
     }
   }
+ if (ssa->len) return 0;
  return DNS_HARD;
 }
 
+int dns_ptr(ssa,ip)
+strsalloc *ssa;
+struct ip_address *ip;
+{
+ int r;
+ int j;
+
+ if (!strsalloc_readyplus(ssa,0)) return DNS_MEM;
+ ssa->len = 0;
+ r = dns_ptrplus(ssa,ip);
+ if (r < 0)
+  {
+   for (j = 0;j < ssa->len;++j)
+    alloc_free(ssa->sa[j].s);
+   ssa->len = 0;
+  }
+ return r;
+}
+
+
 static int dns_ipplus(ia,sa,pref)
 ipalloc *ia;
 stralloc *sa;
 int pref;
 {
  int r;
- struct ip_mx ix;
+ struct ip_mx ix = {0};
 
  if (!stralloc_copy(&glue,sa)) return DNS_MEM;
  if (!stralloc_0(&glue)) return DNS_MEM;
  if (glue.s[0]) {
-   ix.pref = 0;
    if (!glue.s[ip_scan(glue.s,&ix.ip)] || !glue.s[ip_scanbracket(glue.s,&ix.ip)])
     {
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
@@ -293,9 +370,12 @@
    ix.ip = ip;
    ix.pref = pref;
    if (r == DNS_SOFT) return DNS_SOFT;
-   if (r == 1)
+   if (r == 1) {
+     ix.fqdn = glue.s;
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
   }
+  }
+ glue.s = 0;
  return 0;
 }
 
@@ -315,7 +395,7 @@
 {
  int r;
  struct mx { stralloc sa; unsigned short p; } *mx;
- struct ip_mx ix;
+ struct ip_mx ix = {0};
  int nummx;
  int i;
  int j;
@@ -327,7 +407,6 @@
  if (!stralloc_copy(&glue,sa)) return DNS_MEM;
  if (!stralloc_0(&glue)) return DNS_MEM;
  if (glue.s[0]) {
-   ix.pref = 0;
    if (!glue.s[ip_scan(glue.s,&ix.ip)] || !glue.s[ip_scanbracket(glue.s,&ix.ip)])
     {
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
@@ -398,3 +477,49 @@
  alloc_free(mx);
  return flagsoft;
 }
+
+
+static int dns_txtplus(ssa,sa)
+strsalloc *ssa;
+stralloc *sa;
+{
+ int r;
+
+ switch(resolve(sa,T_TXT)) 
+  {
+   case DNS_MEM: return DNS_MEM;
+   case DNS_SOFT: return DNS_SOFT;
+   case DNS_HARD: return DNS_HARD;
+  }
+ while ((r = findtxt(T_TXT)) != 2)
+  {
+   if (r == DNS_SOFT) return DNS_SOFT;
+   if (r == 1)
+    {
+     stralloc sa = {0};
+     if (!stralloc_copyb(&sa,txt+1,(unsigned char)txt[0])) return DNS_MEM;
+     if (!strsalloc_append(ssa,&sa)) return DNS_MEM;
+    }
+  }
+ if (ssa->len) return 0;
+ return DNS_HARD;
+}
+
+int dns_txt(ssa,sa)
+strsalloc *ssa;
+stralloc *sa;
+{
+ int r;
+ int j;
+
+ if (!strsalloc_readyplus(ssa,0)) return DNS_MEM;
+ ssa->len = 0;
+ r = dns_txtplus(ssa,sa);
+ if (r < 0)
+  {
+   for (j = 0;j < ssa->len;++j)
+    alloc_free(ssa->sa[j].s);
+   ssa->len = 0;
+  }
+ return r;
+}
diff -urN qmail-1.03-vanilla/dnscname.c qmail-1.03-md24/dnscname.c
--- qmail-1.03-vanilla/dnscname.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dnscname.c	2007-07-19 20:56:22.000000000 +0200
@@ -8,7 +8,7 @@
 
 stralloc sa = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/dnsfq.c qmail-1.03-md24/dnsfq.c
--- qmail-1.03-vanilla/dnsfq.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dnsfq.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,7 @@
 #include "substdio.h"
 #include "subfd.h"
 #include "stralloc.h"
+#include "strsalloc.h"
 #include "dns.h"
 #include "dnsdoe.h"
 #include "ip.h"
@@ -8,12 +9,15 @@
 #include "exit.h"
 
 stralloc sa = {0};
+strsalloc ssa = {0};
 ipalloc ia = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
+ int j;
+
  if (!argv[1]) _exit(100);
 
  if (!stralloc_copys(&sa,argv[1]))
@@ -25,8 +29,11 @@
   {
    substdio_putsflush(subfderr,"no IP addresses\n"); _exit(100);
   }
- dnsdoe(dns_ptr(&sa,&ia.ix[0].ip));
- substdio_putflush(subfdout,sa.s,sa.len);
- substdio_putsflush(subfdout,"\n");
+ dnsdoe(dns_ptr(&ssa,&ia.ix[0].ip));
+ for(j = 0;j < ssa.len;++j)
+  {
+   substdio_putflush(subfdout,ssa.sa[j].s,ssa.sa[j].len);
+   substdio_putsflush(subfdout,"\n");
+  }
  _exit(0);
 }
diff -urN qmail-1.03-vanilla/dns.h qmail-1.03-md24/dns.h
--- qmail-1.03-vanilla/dns.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dns.h	2007-07-19 20:56:22.000000000 +0200
@@ -3,12 +3,13 @@
 
 #define DNS_SOFT -1
 #define DNS_HARD -2
-#define DNS_MEM -3
+#define DNS_MEM  -3
 
 void dns_init();
 int dns_cname();
 int dns_mxip();
 int dns_ip();
 int dns_ptr();
+int dns_txt();
 
 #endif
diff -urN qmail-1.03-vanilla/dnsip.c qmail-1.03-md24/dnsip.c
--- qmail-1.03-vanilla/dnsip.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dnsip.c	2007-07-19 20:56:22.000000000 +0200
@@ -12,7 +12,7 @@
 stralloc sa = {0};
 ipalloc ia = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/dnsmxip.c qmail-1.03-md24/dnsmxip.c
--- qmail-1.03-vanilla/dnsmxip.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dnsmxip.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "subfd.h"
 #include "stralloc.h"
@@ -14,7 +16,7 @@
 stralloc sa = {0};
 ipalloc ia = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/dnsptr.c qmail-1.03-md24/dnsptr.c
--- qmail-1.03-vanilla/dnsptr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/dnsptr.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,7 @@
 #include "substdio.h"
 #include "subfd.h"
 #include "stralloc.h"
+#include "strsalloc.h"
 #include "str.h"
 #include "scan.h"
 #include "dns.h"
@@ -8,20 +9,25 @@
 #include "ip.h"
 #include "exit.h"
 
-stralloc sa = {0};
+strsalloc ssa = {0};
 struct ip_address ip;
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
+ int j;
+
  if (!argv[1]) _exit(100);
 
  ip_scan(argv[1],&ip);
 
  dns_init(0);
- dnsdoe(dns_ptr(&sa,&ip));
- substdio_putflush(subfdout,sa.s,sa.len);
- substdio_putsflush(subfdout,"\n");
+ dnsdoe(dns_ptr(&ssa,&ip));
+ for(j = 0;j < ssa.len;++j)
+  {
+   substdio_putflush(subfdout,ssa.sa[j].s,ssa.sa[j].len);
+   substdio_putsflush(subfdout,"\n");
+  }
  _exit(0);
 }
diff -urN qmail-1.03-vanilla/dnstxt.c qmail-1.03-md24/dnstxt.c
--- qmail-1.03-vanilla/dnstxt.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/dnstxt.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,32 @@
+#include "substdio.h"
+#include "subfd.h"
+#include "stralloc.h"
+#include "str.h"
+#include "scan.h"
+#include "dns.h"
+#include "dnsdoe.h"
+#include "strsalloc.h"
+#include "exit.h"
+
+strsalloc ssa = {0};
+stralloc sa = {0};
+
+int main(argc,argv)
+int argc;
+char **argv;
+{
+ int j;
+
+ if (!argv[1]) _exit(100);
+
+ if (!stralloc_copys(&sa, argv[1]))
+  { substdio_putsflush(subfderr,"out of memory\n"); _exit(111); }
+ dns_init(0);
+ dnsdoe(dns_txt(&ssa,&sa));
+ for (j = 0;j < ssa.len;++j)
+  {
+   substdio_put(subfdout,ssa.sa[j].s,ssa.sa[j].len);
+   substdio_putsflush(subfdout,"\n");
+  }
+ _exit(0);
+}
diff -urN qmail-1.03-vanilla/envread.c qmail-1.03-md24/envread.c
--- qmail-1.03-vanilla/envread.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/envread.c	2007-07-19 20:56:22.000000000 +0200
@@ -9,7 +9,7 @@
   char *envi;
  
   slen = str_len(s);
-  for (i = 0;envi = environ[i];++i)
+  for (i = 0; (envi = environ[i]); ++i)
     if ((!str_diffn(s,envi,slen)) && (envi[slen] == '='))
       return envi + slen + 1;
   return 0;
diff -urN qmail-1.03-vanilla/error.c qmail-1.03-md24/error.c
--- qmail-1.03-vanilla/error.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/error.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <errno.h>
 #include "error.h"
 
 /* warning: as coverage improves here, should update error_{str,temp} */
@@ -93,3 +92,10 @@
 #else
 -13;
 #endif
+
+int error_dquot =
+#ifdef EDQUOT
+EDQUOT;
+#else
+-14;
+#endif
diff -urN qmail-1.03-vanilla/error.h qmail-1.03-md24/error.h
--- qmail-1.03-vanilla/error.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/error.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,7 +1,7 @@
 #ifndef ERROR_H
 #define ERROR_H
 
-extern int errno;
+#include <errno.h>
 
 extern int error_intr;
 extern int error_nomem;
@@ -16,6 +16,7 @@
 extern int error_pipe;
 extern int error_perm;
 extern int error_acces;
+extern int error_dquot;
 
 extern char *error_str();
 extern int error_temp();
diff -urN qmail-1.03-vanilla/error_str.c qmail-1.03-md24/error_str.c
--- qmail-1.03-vanilla/error_str.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/error_str.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <errno.h>
 #include "error.h"
 
 #define X(e,s) if (i == e) return s;
diff -urN qmail-1.03-vanilla/error_temp.c qmail-1.03-md24/error_temp.c
--- qmail-1.03-vanilla/error_temp.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/error_temp.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,3 @@
-#include <errno.h>
 #include "error.h"
 
 #define X(n) if (e == n) return 1;
diff -urN qmail-1.03-vanilla/except.c qmail-1.03-md24/except.c
--- qmail-1.03-vanilla/except.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/except.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "fork.h"
 #include "strerr.h"
 #include "wait.h"
@@ -6,7 +8,7 @@
 
 #define FATAL "except: fatal: "
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/fd.h qmail-1.03-md24/fd.h
--- qmail-1.03-vanilla/fd.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/fd.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,9 @@
 #ifndef FD_H
 #define FD_H
 
+#include <sys/types.h>
+#include <unistd.h>
+
 extern int fd_copy();
 extern int fd_move();
 
